#!/usr/bin/perl -w
#use strict;

# Allin Cottrell, May 1999.
#
# Add quarterly dates as first column of a datafile,
# given a starting date (of the form 1960.1 or 47.3) 
# and with all non-data lines starting with a "#"
#
# Program is run as a filter

my @datebits;
my ($line, $start, $year, $quart);

if ($#ARGV > -1) { $start = $ARGV[0]; }
else { die 
   "no starting period specified\n"; }   
@datebits = split(/\./,$start);
($#datebits > 0) || die 
      "Invalid starting period \"$start\".\n"; 
$year = $datebits[0]; $quart = $datebits[1];
($quart <= 4) || die "Invalid quarter \"$quart\" in \"$start\".\n";

$quart--;
while (<STDIN>) {
   $line = $_;
   if (/^#/) { print "$line"; next; } # comment line -- ignore
   $quart++;
   if ($quart == 5) { $quart = 1; $year++; }
   print "$year.$quart $line";
}
exit;   
   
